﻿Imports System.Globalization
Imports System.Threading
Imports System.Web.Optimization

Public Class Global_asax
    Inherits HttpApplication

    Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
        BundleConfig.RegisterBundles(BundleTable.Bundles)
        RouteConfig.RegisterRoutes(RouteTable.Routes)
        BundleTable.EnableOptimizations = False
    End Sub

    Sub Session_Start(ByVal sender As Object, ByVal e As EventArgs)
        Dim brojKorisnika As Integer = 0

        If Application("BROJ_KORISNIKA") IsNot Nothing Then
            Integer.TryParse(Application("BROJ_KORISNIKA").ToString(), brojKorisnika)
        End If

        brojKorisnika += 1
        Application("BROJ_KORISNIKA") = brojKorisnika
    End Sub

    Sub Application_BeginRequest(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires at the beginning of each request
    End Sub

    Private Sub Application_AcquireRequestState(sender As [Object], e As EventArgs)
        Try
            If Session("language") IsNot Nothing Then
                Thread.CurrentThread.CurrentUICulture = New CultureInfo(Session("language").ToString())
                Thread.CurrentThread.CurrentCulture = New CultureInfo(Session("language").ToString())
            Else
                Thread.CurrentThread.CurrentUICulture = New CultureInfo("hr")
                Thread.CurrentThread.CurrentCulture = New CultureInfo("hr")
            End If
        Catch
        End Try
    End Sub

    Sub Application_AuthenticateRequest(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires upon attempting to authenticate the use
    End Sub

    'Sub Application_Error(sender As Object, e As EventArgs)
    '    HttpContext.Current.Server.Transfer("~/Error_Page.aspx")
    'End Sub

    Sub Session_End(ByVal sender As Object, ByVal e As EventArgs)
        Dim brojKorisnika As Integer = 0

        If Application("BROJ_KORISNIKA") IsNot Nothing Then
            Integer.TryParse(Application("BROJ_KORISNIKA").ToString(), brojKorisnika)
        End If

        brojKorisnika -= 1
        Application("BROJ_KORISNIKA") = brojKorisnika

    End Sub

    Sub Application_End(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires when the application ends
    End Sub

End Class