﻿
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration

Public Class UMA

    Dim message As String
    Dim dt As New DataTable()


    Public Function dohvatiMaterijale(connString As String, storeProcedure As String) As DataTable

        dt.Clear()

        Dim CMD As New SqlCommand(storeProcedure)

        Dim connection As New SqlConnection(connString)
        CMD.Connection = connection
        CMD.CommandType = CommandType.StoredProcedure

        Dim adapter As New SqlDataAdapter(CMD)
        adapter.SelectCommand.CommandTimeout = 300

        adapter.Fill(dt)

        connection.Close()

        Return dt

    End Function

    Public Function dohvatiMaterijaleEXCEL(connString As String, storeProcedure As String) As DataTable

        dt.Clear()

        Dim CMD As New SqlCommand(storeProcedure)

        Dim connection As New SqlConnection(connString)
        CMD.Connection = connection
        CMD.CommandType = CommandType.StoredProcedure

        Dim adapter As New SqlDataAdapter(CMD)
        adapter.SelectCommand.CommandTimeout = 300

        adapter.Fill(dt)

        connection.Close()

        Return dt

    End Function

    Public Function dohvatiMaterijaleSearch(connString As String, storeProcedure As String, filter As String) As DataTable

        dt.Clear()
        Dim da As SqlDataAdapter

        Using cn As New SqlConnection(connString)
            cn.Open()

            Using cmd As New SqlCommand(storeProcedure, cn)
                Try
                    With cmd
                        .Connection = cn
                        .CommandType = CommandType.StoredProcedure
                        .Parameters.Add("@Name", SqlDbType.NVarChar, 250)
                        .Parameters("@Name").Value = filter
                    End With
                    
                    da = New SqlDataAdapter(cmd)
                    da.Fill(dt)
                Catch ex As Exception

                End Try
            End Using

            Return dt

        End Using

    End Function

    Public Function dohvatiDDLListu(connString As String, storeProcedure As String) As DataTable

        dt.Clear()

        Dim CMD As New SqlCommand(storeProcedure)

        Dim connection As New SqlConnection(connString)
        CMD.Connection = connection
        CMD.CommandType = CommandType.StoredProcedure


        Dim adapter As New SqlDataAdapter(CMD)
        adapter.SelectCommand.CommandTimeout = 300
        adapter.Fill(dt)

        connection.Close()

        Return dt

    End Function

    Public Function spremiMaterijal(connString As String, storeProcedure As String, nazivMaterijala As String, image As String, serijskiBroj As String, opis As String, vrstaMjere As Integer, popust As Integer, jedCijena As Integer) As String

        Dim CMD As New SqlCommand(storeProcedure)

        Dim conn As New SqlConnection(connString)
        CMD.Connection = conn
        CMD.CommandType = CommandType.StoredProcedure
        CMD.Parameters.Add("@NazivMaterijala", SqlDbType.NVarChar)
        CMD.Parameters("@NazivMaterijala").Value = nazivMaterijala.Trim()
        CMD.Parameters.Add("@Image", SqlDbType.NVarChar)
        CMD.Parameters("@Image").Value = image.Trim()
        CMD.Parameters.Add("@SerijskiBroj", SqlDbType.NVarChar)
        CMD.Parameters("@SerijskiBroj").Value = serijskiBroj.Trim()
        CMD.Parameters.Add("@Opis", SqlDbType.NVarChar)
        CMD.Parameters("@Opis").Value = opis.Trim()
        CMD.Parameters.Add("@VrstaMjere", SqlDbType.Int)
        CMD.Parameters("@VrstaMjere").Value = vrstaMjere
        CMD.Parameters.Add("@Popust", SqlDbType.Int)
        CMD.Parameters("@Popust").Value = popust
        CMD.Parameters.Add("@JedCijena", SqlDbType.Int)
        CMD.Parameters("@JedCijena").Value = jedCijena

        Try
            conn.Open()
            CMD.ExecuteNonQuery()
            message = "Materijal uspješno spremljen."

        Catch ex As Exception
            message = ex.Source + " " + ex.Message
        Finally
            conn.Close()
            conn.Dispose()
        End Try

        Return message

    End Function

    Public Function promjeniMaterijal(connString As String, storeProcedure As String, idMaterijala As Integer, nazivMaterijala As String, imageMat As String, serijskiBroj As String, opis As String, vrstaMjere As Integer, popust As Integer, jedCijena As Integer) As String

        Dim CMD As New SqlCommand(storeProcedure)

        Dim conn As New SqlConnection(connString)
        CMD.Connection = conn
        CMD.CommandType = CommandType.StoredProcedure
        CMD.Parameters.Add("@MaterialID", SqlDbType.Int)
        CMD.Parameters("@MaterialID").Value = idMaterijala
        CMD.Parameters.Add("@NazivMaterijala", SqlDbType.NVarChar)
        CMD.Parameters("@NazivMaterijala").Value = nazivMaterijala.Trim()
        CMD.Parameters.Add("@Image", SqlDbType.NVarChar)
        CMD.Parameters("@Image").Value = imageMat.Trim()
        CMD.Parameters.Add("@SerijskiBroj", SqlDbType.NVarChar)
        CMD.Parameters("@SerijskiBroj").Value = serijskiBroj.Trim()
        CMD.Parameters.Add("@Opis", SqlDbType.NVarChar)
        CMD.Parameters("@Opis").Value = opis.Trim()
        CMD.Parameters.Add("@VrstaMjere", SqlDbType.Int)
        CMD.Parameters("@VrstaMjere").Value = vrstaMjere
        CMD.Parameters.Add("@Popust", SqlDbType.Int)
        CMD.Parameters("@Popust").Value = popust
        CMD.Parameters.Add("@JedCijena", SqlDbType.Int)
        CMD.Parameters("@JedCijena").Value = jedCijena

        Try
            conn.Open()
            CMD.ExecuteNonQuery()
            message = "Materijal uspješno promjenjen."

        Catch ex As Exception
            message = ex.Source + " " + ex.Message
        Finally
            conn.Close()
            conn.Dispose()
        End Try

        Return message

    End Function


End Class
